/***************************************************************************
                          designoptions.h  -  description
                             -------------------
    begin                : Wed Feb 27 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef DESIGNOPTIONS_H
#define DESIGNOPTIONS_H

#include <vector>
#include "figureoptions.h"

using namespace std;
class ConfigFile;
class QWidget;

const int DesignOptions_KeyNum = 7;
const int DesignOptions_MaxAnimationSpeed = 7;

struct DesignOptions
{
  enum
  {
    KeyLeft = 0, KeyRight = 1, KeyDrop = 2, KeyRotate = 3,
    KeyRotateBackward = 4, KeyAccelerate = 5, KeyJumpBound = 6
  };

  int KeyCodes[DesignOptions_KeyNum];
  int BeforeKeyRepeatInterval;
  int KeyRepeatRate;
  bool Color;
  QString BackgroundFileName;
  QString ElementsFileName;
  int ElementSize;
  int GridInterval;
  bool SmartRotate;
  int AnimationSpeed;
  bool SmoothMovement;

  // Array of FigureOptions for each figure collection
  vector<FigureOptions> FFigureOptions;

  DesignOptions();
};

void bindDesignOptions(ConfigFile & file, const QString & sect, DesignOptions & opt);
void editDesignOptions(QWidget * parent, const QString & caption,
  DesignOptions & opt, int FigureCollectionNumber);

#endif
