/***************************************************************************
                          designoptionsdlg.h  -  description
                             -------------------
    begin                : Mon Mar 4 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef DESIGNOPTIONSDLG_H
#define DESIGNOPTIONSDLG_H

#include <qdialog.h>
#include "designoptions.h"

class KeyEdit;
class QSlider;
class QCheckBox;
class FileEdit;
class QSpinBox;
class QComboBox;

/**
  *@author Dmitry Osinovsky
  */

class DesignOptionsDlg : public QDialog  {
   Q_OBJECT
public:
  DesignOptionsDlg(QWidget *parent=0, const char *name=0);
  ~DesignOptionsDlg();

  void editOptions(const QString & caption, DesignOptions & opt, int FigureCollectionNumber);

  KeyEdit * FKeys[DesignOptions_KeyNum];
  QSlider * FBeforeKeyRepeatInterval;
  QSlider * FKeyRepeatRate;
  QCheckBox * FSmartRotate;
  QCheckBox * FColor;
  FileEdit * FBackgroundImage;
  FileEdit * FElementsImage;
  QSpinBox * FElementSize;
  QComboBox * FGridInterval;
  QSlider * FAnimationSpeed;
  QCheckBox * FSmoothMovement;
  int FFigureCollectionNumber;
  DesignOptions * FOpt;

protected slots:
  void figureOptionsClicked();
};

#endif
