/***************************************************************************
                          figurecollections.cpp  -  description
                             -------------------
    begin                : Mon Mar 18 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#include "figurecollections.h"

void FigureCollection::addFigures(int FigureNumber, int ContentsFigureSize,
  int * Contents, bool AllowRotate)
{
  for (int i = 0; i < FigureNumber; i ++)
  {
    Figure * fig = new Figure();
    fig -> initialize(FFigureSize,
      Contents + i*ContentsFigureSize*ContentsFigureSize,
      ContentsFigureSize);

    if (!AllowRotate)
    {
      /* Shit!
       * It seems like I've done wrong initialization, so width and height got swapped.
       * It does matter only on arcade levels, so need to rotate it now to correct its position.
       */
      fig -> rotate();
      fig -> rotate();
      fig -> rotate();
    }
    fig -> setAllowRotate(AllowRotate);
    FFigures.push_back(fig);
  }
}

int FigureCollection::figureNumber(int ElementNum) const
{
  int FigureCount = 0;
  for (int i = 0; i < figureNumber(); i ++)
  {
    if (at(i)->elementNum() == ElementNum)
      FigureCount ++;
  }
  return FigureCount;
}

FigureCollection::FigureCollection(const QString & Name, const QString & Code,
  int ScoreNum, int FigureSize)
{
  FName = Name;
  FCode = Code;
  FScoreNum = ScoreNum;
  FFigureSize = FigureSize;
}

FigureCollection::~FigureCollection()
{
  for (unsigned i = 0; i < FFigures.size(); i ++)
  {
    delete FFigures[i];
  }
}

FigureCollections::~FigureCollections()
{
  for (unsigned i = 0; i < FCollections.size(); i ++)
    delete FCollections[i];
}

FigureCollections FigureCollections::FSingleton;

const FigureCollections * FigureCollections::instance()
{
  if (! FSingleton.FInited)
  {
    FSingleton.initialize();
  }
  return & FSingleton;
}

const int TET_FigureNumber = 7;
extern int TET_Figures[4*4*TET_FigureNumber];
const int SmallFigureNumber = 4;
extern int SmallFigures[4*4*SmallFigureNumber];
const int PentixFigureNumber = 18;
extern int PentixFigures[5*5*PentixFigureNumber];
const int ArcadeLevelsNumber = 5;
extern int ArcadeLevels[10*10*ArcadeLevelsNumber];

void FigureCollections::initialize()
{
  FigureCollection * col;

  col = new FigureCollection(tr("Tetris"), "Tetris", 1, 4);
  col->addFigures(TET_FigureNumber, 4, TET_Figures);
  FCollections.push_back(col);

  col = new FigureCollection(tr("Pentix"), "Pentix", 2, 5);
  col->addFigures(TET_FigureNumber, 4, TET_Figures);
  col->addFigures(SmallFigureNumber, 4, SmallFigures);
  col->addFigures(PentixFigureNumber, 5, PentixFigures);
  FCollections.push_back(col);

  col = new FigureCollection(tr("ArcadeLevels"), "ArcadeLevels", 2, 10);
  col->addFigures(ArcadeLevelsNumber, 10, ArcadeLevels, false);
  FCollections.push_back(col);

  FInited = true;
}

int TET_Figures[4*4*TET_FigureNumber] = {
/*
  0, 5, 0, 0,
  0, 5, 0, 0,
  0, 5, 5, 0,
  0, 0, 0, 0,

  0, 4, 0, 0,
  0, 4, 0, 0,
  0, 4, 0, 0,
  0, 4, 0, 0,

  0, 1, 0, 0,
  0, 1, 1, 0,
  0, 1, 0, 0,
  0, 0, 0, 0,

  0, 6, 6, 0,
  0, 6, 0, 0,
  0, 6, 0, 0,
  0, 0, 0, 0,

  0, 0, 0, 0,
  0, 2, 2, 0,
  0, 2, 2, 0,
  0, 0, 0, 0,

  0, 7, 0, 0,
  0, 7, 7, 0,
  0, 0, 7, 0,
  0, 0, 0, 0,

  0, 0, 3, 0,
  0, 3, 3, 0,
  0, 3, 0, 0,
  0, 0, 0, 0
*/
  0, 20, 0, 0,
  0, 20, 0, 0,
  0, 20, 20, 0,
  0, 0, 0, 0,

  0, 18, 0, 0,
  0, 18, 0, 0,
  0, 18, 0, 0,
  0, 18, 0, 0,

  0, 2, 0, 0,
  0, 2, 2, 0,
  0, 2, 0, 0,
  0, 0, 0, 0,

  0, 24, 24, 0,
  0, 24, 0, 0,
  0, 24, 0, 0,
  0, 0, 0, 0,

  0, 0, 0, 0,
  0, 6, 6, 0,
  0, 6, 6, 0,
  0, 0, 0, 0,

  0, 26, 0, 0,
  0, 26, 26, 0,
  0,  0, 26, 0,
  0, 0, 0, 0,

  0, 0, 8, 0,
  0, 8, 8, 0,
  0, 8, 0, 0,
  0, 0, 0, 0
};

int SmallFigures[4*4*SmallFigureNumber] = {
  0, 18, 0, 0,
  0, 18, 0, 0,
  0, 18, 0, 0,
  0, 0, 0, 0,

  0, 3, 0, 0,
  0, 3, 3, 0,
  0, 0, 0, 0,
  0, 0, 0, 0,

  0, 18, 0, 0,
  0, 18, 0, 0,
  0, 0, 0, 0,
  0, 0, 0, 0,

  0, 0, 0, 0,
  0, 18, 0, 0,
  0, 0, 0, 0,
  0, 0, 0, 0
};

int PentixFigures[5*5*PentixFigureNumber] = {
  0, 0, 4, 0, 0,
  0, 0, 4, 0, 0,
  0, 0, 4, 0, 0,
  0, 0, 4, 0, 0,
  0, 0, 4, 0, 0,

  0, 0, 5, 0, 0,
  0, 0, 5, 0, 0,
  0, 0, 5, 5, 5,
  0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0, 7, 7, 0, 0,
  0, 0, 7, 7, 0,
  0, 0, 0, 7, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0, 9, 0, 9, 0,
  0, 9, 9, 9, 0,
  0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,

  0, 10, 0, 0, 0,
  0, 10, 0, 0, 0,
  0, 10, 0, 0, 0,
  0, 10, 10, 0, 0,
  0, 0, 0, 0, 0,

  0,  0, 11, 0, 0,
  0,  0, 11, 0, 0,
  0,  0, 11, 0, 0,
  0, 11, 11, 0, 0,
  0, 0, 0, 0, 0,

  0,  0, 12, 0, 0,
  0,  0, 12, 0, 0,
  0, 12, 12, 0, 0,
  0,  0, 12, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 13, 0, 0,
  0, 0, 13, 0, 0,
  0, 0, 13, 13, 0,
  0, 0, 13, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0, 0, 14, 0, 0,
  0, 0, 14, 14, 0,
  0, 0, 14, 14, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0,  0, 15, 0, 0,
  0, 15, 15, 0, 0,
  0, 15, 15, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0,  0, 16, 0, 0,
  0,  0, 16, 16, 0,
  0, 16, 16, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0,  0, 17, 0, 0,
  0, 17, 17, 0, 0,
  0,  0, 17, 17, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0, 19, 19, 0, 0,
  0,  0, 19, 0, 0,
  0,  0, 19, 19, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0,  0, 21, 21, 0,
  0,  0, 21, 0, 0,
  0, 21, 21, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0,  0, 22, 0, 0,
  0,  0, 22, 0, 0,
  0, 22, 22, 22, 0,
  0, 0, 0, 0, 0,

  0,  0, 23, 0, 0,
  0,  0, 23, 0, 0,
  0, 23, 23, 0, 0,
  0, 23, 0, 0, 0,
  0, 0, 0, 0, 0,

  0, 25, 0, 0, 0,
  0, 25, 0, 0, 0,
  0, 25, 25, 0, 0,
  0,  0, 25, 0, 0,
  0, 0, 0, 0, 0,

  0, 0, 0, 0, 0,
  0, 0, 1, 0, 0,
  0, 1, 1, 1, 0,
  0, 0, 1, 0, 0,
  0, 0, 0, 0, 0
};

int ArcadeLevels[10*10*ArcadeLevelsNumber] = {
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  4, 4, 4, 4, 4, 0, 0, 4, 0, 4,
  0, 0, 1, 0, 0, 0, 0, 0, 4, 0,
  0, 7, 1, 1, 1, 1, 1, 4, 1, 4,
  7, 7, 1, 7, 7, 1, 1, 1, 0, 0,
  1, 1, 1, 7, 7, 1, 0, 0, 0, 0,
  0, 1, 1, 1, 1, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
  0, 0, 0, 0, 0, 0, 1, 1, 0, 0,
  0, 0, 1, 1, 1, 1, 1, 1, 0, 0,
  0, 1, 1, 2, 2, 2, 1, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

  /*0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  3, 0, 0, 0, 0, 0, 0, 0, 0, 3,
  3, 0, 0, 0, 0, 0, 0, 0, 0, 3,
  3, 3, 3, 3, 0, 0, 3, 3, 3, 3,
  0, 3, 3, 3, 3, 3, 3, 3, 3, 0,
  0, 0, 3, 3, 3, 3, 3, 3, 0, 0,
  0, 0, 0, 3, 3, 3, 3, 0, 0, 0,
  0, 0, 0, 0, 3, 3, 0, 0, 0, 0,
  0, 0, 0, 0, 3, 3, 0, 0, 0, 0,
  0, 0, 0, 3, 3, 3, 3, 0, 0, 0,

  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 2, 2, 2, 2, 0, 0, 0,
  0, 0, 2, 2, 2, 2, 2, 2, 0, 0,
  0, 0, 2, 2, 4, 4, 2, 2, 0, 0,
  0, 0, 2, 2, 4, 4, 2, 2, 0, 0,
  0, 0, 2, 2, 4, 4, 2, 2, 0, 0,
  0, 0, 0, 2, 4, 4, 2, 0, 0, 0,
  0, 0, 0, 0, 4, 4, 0, 0, 0, 0,
  0, 0, 0, 0, 4, 4, 0, 0, 0, 0,
  0, 0, 0, 4, 4, 4, 4, 0, 0, 0,


  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 3, 3, 0, 0, 0, 0,
  0, 0, 0, 3, 0, 0, 3, 0, 0, 0,
  0, 0, 3, 0, 0, 0, 0, 3, 0, 0,
  0, 3, 0, 0, 0, 0, 0, 0, 3, 0,
  3, 0, 0, 0, 0, 0, 0, 0, 0, 3,*/

  2, 0, 0, 0, 0, 0, 0, 0, 0, 2,
  2, 2, 0, 0, 0, 0, 0, 0, 2, 2,
  2, 0, 2, 0, 0, 0, 0, 2, 0, 2,
  2, 0, 0, 2, 0, 0, 2, 0, 0, 2,
  2, 0, 0, 0, 2, 2, 0, 0, 0, 2,
  2, 0, 0, 0, 2, 2, 0, 0, 0, 2,
  2, 0, 0, 0, 0, 0, 0, 0, 0, 2,
  2, 0, 0, 0, 0, 0, 0, 0, 0, 2,
  2, 0, 0, 0, 0, 0, 0, 0, 0, 2,
  2, 0, 0, 0, 0, 0, 0, 0, 0, 2,

  4, 0, 0, 0, 4, 0, 0, 0, 0, 4,
  0, 4, 0, 0, 0, 4, 0, 0, 4, 0,
  0, 0, 4, 0, 4, 0, 0, 4, 0, 0,
  0, 0, 0, 4, 0, 4, 4, 0, 0, 0,
  0, 0, 0, 0, 4, 4, 0, 0, 0, 0,
  0, 0, 0, 0, 4, 4, 0, 0, 0, 0,
  0, 0, 0, 4, 4, 0, 4, 0, 0, 0,
  0, 0, 4, 0, 0, 4, 0, 4, 0, 0,
  0, 4, 0, 0, 4, 0, 0, 0, 4, 0,
  4, 0, 0, 0, 0, 4, 0, 0, 0, 4,

  0, 0, 0, 0, 5, 5, 0, 0, 0, 0,
  0, 0, 0, 0, 5, 5, 0, 0, 0, 0,
  0, 0, 0, 5, 0, 0, 5, 0, 0, 0,
  0, 0, 0, 5, 0, 0, 5, 0, 0, 0,
  0, 5, 0, 5, 0, 0, 5, 0, 5, 0,
  0, 5, 5, 5, 0, 0, 5, 5, 5, 0,
  0, 5, 0, 5, 0, 0, 5, 0, 5, 0,
  5, 5, 0, 0, 0, 0, 0, 0, 5, 5,
  5, 5, 0, 0, 0, 0, 0, 0, 5, 5,
  5, 0, 0, 0, 0, 0, 0, 0, 0, 5
};
