/***************************************************************************
                          figurecollections.h  -  description
                             -------------------
    begin                : Mon Mar 18 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef FIGURECOLLECTIONS_H
#define FIGURECOLLECTIONS_H

#include <vector>
#include <map>
#include <qobject.h>
#include <qstring.h>
#include "figure.h"

using namespace std;

class FigureCollection
{
public:
  FigureCollection(const QString & Name, const QString & Code,
    int ScoreNum, int FigureSize);
  ~FigureCollection();
  void addFigures(int FigureNumber, int ContentsFigureSize,
    int * Contents, bool AllowRotate = true);

  int figureNumber() const { return FFigures.size(); }
  int figureNumber(int ElementNum) const;
  const Figure * operator[](int FigNum) const { return FFigures[FigNum]; }
  const Figure * at(int FigNum) const { return FFigures[FigNum]; }
  QString name() const { return FName; }
  QString code() const { return FCode; }
  int figureSize() const { return FFigureSize; }
  int scoreNum() const { return FScoreNum; }
private:
  vector<Figure *> FFigures;
  int FFigureSize;
  QString FName;
  QString FCode;
  int FScoreNum;
};

class FigureCollections : public QObject
{
  Q_OBJECT
public:
  FigureCollections(): FInited(false) {}
  ~FigureCollections();

  int collectionNumber() const { return FCollections.size(); }
  const FigureCollection * operator[](int ColNum) const { return FCollections[ColNum]; }
  const FigureCollection * at(int ColNum) const { return FCollections[ColNum]; }

  static const FigureCollections * instance();
private:
  void initialize();
  vector<FigureCollection *> FCollections;
  static FigureCollections FSingleton;
  bool FInited;
};

#endif
