/***************************************************************************
                          figureoptions.h  -  description
                             -------------------
    begin                : Sun Mar 17 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef FIGUREOPTIONS_H
#define FIGUREOPTIONS_H

#include <qstring.h>
#include <vector>
#include "figurecollections.h"

using namespace std;

class QWidget;
class ConfigFile;

struct OneFigureOptions
{
  int Color;
  int RotatePosition;
  OneFigureOptions(): Color(-1), RotatePosition(0) {}
};

struct FigureOptions
{
  vector<OneFigureOptions> Options;
  const FigureCollection * Figures;

  void initialize(const FigureCollection * F)
  {
    Options.resize(F->figureNumber());
    Figures = F;
  }

  FigureOptions(): Figures(0) {}
};

void bindFigureOptions(ConfigFile & file, const QString & sect, FigureOptions & opt);
void editFigureOptions(QWidget * parent, FigureOptions & opt);

#endif

