/***************************************************************************
                          figureoptionsdlg.h  -  description
                             -------------------
    begin                : Sun Mar 17 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef FIGUREOPTIONSDLG_H
#define FIGUREOPTIONSDLG_H

#include <qwidget.h>
#include <qdialog.h>
#include <qhbox.h>

#include "figureoptions.h"
#include "buttongrid.h"
#include "figure.h"

class FigureElement: public QHBox
{
  Q_OBJECT
public:
  FigureElement(QWidget *parent=0);
  ~FigureElement();

  void initialize(int Color, int Rotate,
    const Figure * Figure);
  int color() { return FFigure.color(); }
  int rotate() { return FRotate; }
protected slots:
  void rotateClicked();
  void colorClicked();

private:
  ButtonGrid * FGrid;
  Figure FFigure;
  int FRotate;
};

class FigureOptionsDlg : public QDialog  {
  Q_OBJECT
public: 
	FigureOptionsDlg(QWidget *parent=0, const char *name=0);
	~FigureOptionsDlg();
	
	void editOptions(FigureOptions & opt);
private:
  FigureElement ** FElements;
};

#endif
