/***************************************************************************
                          highscore.h  -  description
                             -------------------
    begin                : Mon Mar 4 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HIGHSCORE_H
#define HIGHSCORE_H

#include <qwidget.h>
#include <qdialog.h>
#include <qstring.h>

class QListView;
struct SkillOptions;
/**
  *@author Dmitry Osinovsky
  */

class HighScore : public QDialog  {
   Q_OBJECT
public:
  HighScore(int FigureCollection,
    QWidget *parent=0, const char *name=0);
  ~HighScore();

  void showHighScore();
  void gameEnd(long Score, int Lines,
    const SkillOptions & StartOptions);
protected:
  void loadHighScore();
  void saveHighScore();
  void resetHighScore();

protected slots:
  void slotResetHighScore();

private:
  QListView * FMainScore;
  QString FLastPlayerName;
  int FFigureCollection;
};

#endif
