/***************************************************************************
                          keyedit.cpp  -  description
                             -------------------
    begin                : Wed Feb 27 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#include <qaccel.h>
#include "keyedit.h"

KeyEdit::KeyEdit(QWidget *parent, const char *name )
  : QLineEdit(parent,name), FKey(0)
{
}

KeyEdit::~KeyEdit(){
}
/**  */
void KeyEdit::keyPressEvent(QKeyEvent * e)
{
  setKey(e->key());
}

void KeyEdit::setKey(int Key)
{
  if (Key == 0)
    setText("");
  else if (Key == Key_Control)
    setText(tr("Ctrl"));
  else if (Key == Key_Shift)
    setText(tr("Shift"));
  else if (Key == Key_Alt)
    setText(tr("Alt"));
  else if (Key == Key_Meta)
    setText(tr("Meta"));
  else if (Key == Key_Menu)
    setText(tr("Menu"));
  else
    setText(QAccel::keyToString(Key));
  FKey = Key;
}

void KeyEdit::mousePressEvent(QMouseEvent *)
{
  setKey(0);
}
