/***************************************************************************
                          multioptions.h  -  description
                             -------------------
    begin                : Fri Mar 1 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef MULTIOPTIONS_H
#define MULTIOPTIONS_H

#include <qstring.h>
#include "quadrosprotocol.h"

struct SkillOptions;
class ConfigFile;

struct NetOptions
{
 	int
    SecBeforeStart,
 		MaxScores;
 	ThrowTo
 		TeamToThrow,
    PlayerToThrow;
  int
 	  PlayerExitScores,
 		TeamExitScores;
 	bool
    TraceMessages;
};

struct NetDefaultSettings
{
  QString PlayerName1;
  QString TeamName1;
  QString PlayerName2;
  QString TeamName2;
  QString Host;
  QString Port;
  bool SecondPlayer;
  enum {gtLocalPlay, gtCreateNetGame, gtJoinNetGame} GameType;
};

void bindNetOptions(ConfigFile & file, const QString & sect,
  NetOptions & opt1, NetDefaultSettings & opt2);

bool askMultiplayerOptions(QWidget * parent,
  NetOptions & opt1, NetDefaultSettings & opt2,
  SkillOptions & opt3);

#endif
