/***************************************************************************
                          multiplayerstats.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qsplitter.h>
#include "multiplayerstats.h"

MultiPlayerStats::MultiPlayerStats(QWidget *parent, const char *name ) :
  QVBox(parent,name)
{
  setSpacing(5);

  QHBox * TopBox = new QHBox(this);
  TopBox -> setMaximumSize( QSize(32767, 30) );
  TopBox -> setSpacing(5);
  FStartBtn = new QPushButton(TopBox);
  FStartBtn -> setText(tr("Start game"));

  FExitBtn = new QPushButton(TopBox);
  FExitBtn -> setText(tr("Exit multiplayer"));

  QSplitter * Splitter = new QSplitter(QSplitter::Vertical, this);
  FTeams = new QListView(Splitter);

	FTeams -> addColumn("Team", 90);
	FTeams -> addColumn("Height", 42);
	FTeams -> addColumn("Score", 40);
	FTeams -> addColumn("Total", 35);
	
  FLog = new QMultiLineEdit(Splitter);
  FLog -> setReadOnly(true);
  FLog -> setWordWrap(QMultiLineEdit::WidgetWidth);

  QHBox * BottomBox = new QHBox(this);
  BottomBox -> setMaximumSize( QSize(32767, 30) );
  BottomBox -> setSpacing(5);
  FMessage = new QLineEdit(BottomBox);

  FSendBtn = new QPushButton(BottomBox);
  FSendBtn -> setText(tr("Send"));
  FSendBtn -> setMaximumSize( QSize(50, 32767) );

  FMsgDlg = new QMessageBox(tr("QuadrOs - Multiplayer"), "",
    QMessageBox::Information, QMessageBox::Ok,
    QMessageBox::NoButton, QMessageBox::NoButton,
    this, 0, false);
}

MultiPlayerStats::~MultiPlayerStats()
{
}

