/***************************************************************************
                          ooprandom.h  -  description
                             -------------------
    begin                : Sun Feb 24 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

// Object-oriented random number generator

#ifndef OOPRANDOM_H
#define OOPRANDOM_H

const int OO_RAND_MAX = 0x7fffffff;
const int STATE_LENGTH = 256;

typedef	int int32_t;
class RandomGenerator
{
private:
  struct random_data
  {
    int32_t *fptr;		/* Front pointer.  */
    int32_t *rptr;		/* Rear pointer.  */
    int32_t *state;		/* Array of state values.  */
    int rand_type;		/* Type of random number generator.  */
    int rand_deg;		/* Degree of random number generator.  */
    int rand_sep;		/* Distance between front and rear.  */
    int32_t *end_ptr;		/* Pointer behind state table.  */
  } buf;

  char arg_state[STATE_LENGTH];

  int srandom(unsigned int seed, random_data * buf);

public:
	RandomGenerator(unsigned int seed = 1) { SetSeed(seed); }
	void SetSeed(unsigned int seed);
	int32_t operator() ();
};

#endif
