/***************************************************************************
                          quadrosclientsocket.h  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QUADROSCLIENTSOCKET_H
#define QUADROSCLIENTSOCKET_H

#include <qobject.h>
#include "quadrosprotocol.h"
#include "multioptions.h"
#include "skilloptions.h"
#include "nettransport.h"

class MultiPlayerStats;
class QuadrOsDoc;

/**
  *@author Dmitry Osinovsky
  */

class QuadrOsClientSocket : public QObject, public IReceiver  {
  Q_OBJECT
public:
	void StartGame();
	void SendOptions();
	
	MultiPlayerStats * FStats;
	QuadrOsDoc * FDoc;
	SkillOptions FOptions;
	NetOptions FNetOptions;
	
	QString m_MessageOnClose;
	bool m_bServer;
	NetTransport * FTransport;

	QuadrOsClientSocket(MultiPlayerStats * Stats, QuadrOsDoc * Doc);
	
	void ConnectToServer(bool bServer,
    NetTransport * Transport, QString PlayerName, QString Team);
	virtual bool receiveOne();
	virtual void onClose();
	void close();
	bool isConnected();
	virtual ~QuadrOsClientSocket();
	
	void pauseOn();
	void pauseOff();
	void sendMessage(QString str);
	
public slots:
	void gameFinished();
  void figureDropped(long Score, int, int, int Height, int CollapsedLines);
};

#endif
