/***************************************************************************
                          quadroslistener.h  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QUADROSLISTENER_H
#define QUADROSLISTENER_H

#include <qserversocket.h>
#include <map>
#include <vector>
#include "ooprandom.h"
#include "quadrosprotocol.h"

using namespace std;
/** Adapter classes to ease porting from MFC
  */

/*class CCollElement
{
};

typedef void * POSITION;

typedef QListIterator<CCollElement> CListIterator;
typedef CListIterator * PListIterator;

class CObList: public QList<CCollElement>
{
public:
  CObList() { setAutoDelete(false); }

  POSITION GetHeadPosition()
  { return isEmpty() ? NULL : new CListIterator(*this); }

  CCollElement * GetNext(POSITION & pos)
  {
    PListIterator pIter = PListIterator(pos);
    CCollElement * res = pIter -> current();
    if (pIter -> atLast())
    {
      delete pIter;
      pos = NULL;
    }
    else
      ++ *pIter;
    return res;
  }

  int GetCount() { return count(); }
};

typedef QDictIterator<CCollElement> CDictIterator;
typedef CDictIterator * PDictIterator;
class CMapStringToOb: public QDict<CCollElement>
{
public:
  CMapStringToOb() { setAutoDelete(false); }
  int GetCount() { return count(); }
  POSITION GetStartPosition()
  { return isEmpty() ? NULL : new CDictIterator(*this); }

  void GetNextAssoc(POSITION & pos, QString & key,
    CCollElement * & obj)
  {
    PDictIterator pIter = PDictIterator(pos);
    obj = pIter -> current();
    key = pIter -> currentKey();
    ++ (*pIter);
    if (! pIter -> current())
    {
      delete pIter;
      pos = NULL;
    }
  }
};*/

class QuadrOsServerSocket;
class CTeam;

/**
  *@author Dmitry Osinovsky
  */

typedef map<QString, CTeam *> TeamMap;

class QuadrOsListener : public QServerSocket {
public:
  QString ThrowTo2Str(ThrowTo TT, bool ToTeam);
	QString ThrowLines(int Lines, CTeam * Except);
	void OnTimer();
	void Broadcast(const QString Message);
	void EndGame();
	void StartGame(int StartLevel);
	void RefreshPlayersInfo();
	virtual void Close();

	int FTimerCounter;
	vector<QuadrOsServerSocket *> m_Socks;
	TeamMap m_Teams;
	int InitialPlayerNumber, InitialTeamNumber;
	int m_nRefreshPlayerTicks;
	int m_TimerTicks, m_SecBeforeStart;
	int m_AddedLines;
	RandomGenerator m_RanGen;

	bool m_bPlaying, m_bInited;
	bool m_bClosing;

	int	NET_StartLevel, SKILL_Height;
	bool IncreaseLevel;

	ThrowTo
		NET_TeamToThrow,
		NET_PlayerToThrow;

	bool
		NET_PendLines, // pend popping in bottom lines till figure fall
		NET_CountOnlyExitScores;

	bool
		NET_TraceMessages;

	int
		NET_PlayerExitScores,
		NET_TeamExitScores;

	unsigned int
		NET_SecBeforeStart,
		NET_MaxScores;
		
	int FFigureCollectionNumber;

	void init();
	
	// Constructor() for local playing - no real networking
	QuadrOsListener() { init(); }
	QuadrOsListener(Q_UINT16 port): QServerSocket(port) { init(); }
	void newConnection(int socket);
};

class NetTransport;

class QuadrOsServerSocket: public IReceiver
{
public:
	void ThrowLines(int Lines);
	void PlayerStopGame();
	void SendOptions();
	
	QuadrOsListener * m_pListener;
	CTeam * m_pTeam;
	QString m_PlayerName;
	QString m_Team;
	bool m_bPlaying;
	int Height, PendingLines, m_AddedLines;
	long Score, TotalScore;
	int m_TotalStats[4], m_Stats[4];
	NetTransport * FTransport;

	QuadrOsServerSocket(QuadrOsListener * pListener, NetTransport * Transport);

	virtual bool receiveOne();
	virtual void onClose();
	virtual ~QuadrOsServerSocket() { delete FTransport; }
};

class CTeam
{
public:
	int GetStrength();
	QString ThrowLines(int Lines);
	vector<QuadrOsServerSocket *> m_Players;
	int m_Score, m_TotalScore, m_Number, m_SentLines, m_AddedLines;
	QuadrOsListener * m_pListener;
	QString m_Name;
	bool m_bPlaying;

	CTeam(): m_Score(0), m_TotalScore(0), m_Number(-1),
		m_SentLines(0), m_AddedLines(0) {}
	void AddPlayer(QuadrOsServerSocket * pPlayer);
	void DeletePlayer(QuadrOsServerSocket * pPlayer);
	virtual ~CTeam();
};
#endif
