/***************************************************************************
                          quadrosview.h  -  description
                             -------------------
    begin                : Feb 24 00:04:59 MSK 2002
    copyright            : (C) 2002 by Dmitry Osinovsky
    email                : osdm@mail.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QUADROSVIEW_H
#define QUADROSVIEW_H

// include files for QT
#include <qwidget.h>
#include <qhbox.h>

// application specific includes
#include "designoptions.h"

class ButtonGrid;
class QLCDNumber;
class QuadrOsDoc;
class QuadrOsAI;

class QuadrOsView : public QHBox
{
  Q_OBJECT
private:
  ButtonGrid * FMainField;
  ButtonGrid * FNextFigure;
  ButtonGrid * FHelperLine;
  QLCDNumber * FScoreLCD;
  QLCDNumber * FLevelLCD;
  QLCDNumber * FLinesLCD;
  QuadrOsDoc * FDoc;
  DesignOptions FOptions;
  int FLeftKeyState;
  int FRightKeyState;
  bool FKeyBoundState;
  int FKeyAccelerateState;
  int FScore, FAnimatedScore;
  QuadrOsAI * FAI;

public:
  QuadrOsView(QWidget *parent=0, QuadrOsDoc* doc=0);
  ~QuadrOsView();
  void resize ( int w, int h );
  QSizePolicy sizePolicy() const
  { return QSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed); }

  void parentKeyReleaseEvent(QKeyEvent * e);
  void parentKeyPressEvent(QKeyEvent * e);
  void parentFocusOut();
  DesignOptions getOptions() { return FOptions; }
  void setOptions(const DesignOptions Options);
  void onTimer();
  void turnAIOn(bool Aggressive, int AISpeed);
  void turnAIOff();
  bool isAIOn() { return FAI != 0; }

protected: // Protected methods
  /**  */
  void clearKeyboardState();

public slots:
  void updateStats(long Score, int Level, int Lines, int);
  void pauseOn();
  void pauseOff();
};

#endif
